// Mix stereo channels into a mono output soundfile
//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Wed May 28 20:07:37 GMT-0800 1997
// Last Modified: Wed May 28 20:07:40 GMT-0800 1997
// Filename:      .../sig/examples/collapse/collapse.cc
// Syntax:        C++ 
//

#include "Dependencies.h"
#include <iostream.h>

void exitUsage(char *commandName);


int main(int argc, char* argv[]) {
   if (argc != 3) exitUsage(argv[0]); 

   SoundHeader header(argv[1]);
   header.setChannels(1);

   float amplitude;
   cout << "Enter the amplitude scaling of the sound: ";
   cin  >> amplitude;

   // Elements:
   SoundFileIn  insound(argv[1]);
   SoundFileOut outsound(argv[2], header);
   Add          add;
   Scale        scale(amplitude);

   // Connections:
   outsound.connect(scale);
   scale.connect(add);
   for (int i=0; i<insound.getChannels(); i++) {
      add.connect(insound, i, i);
   }

   Action action;
   action.tick(outsound, insound.getSamples());


   return 0;
}



void exitUsage(char* commandName) {
   cout << endl;
   cout << "Adds all channels in a soundfile into one mono soundfile." << endl;
   cout << endl;
   cout << "Usage: " << commandName << " insound outsound" << endl;
   cout << endl;
   cout << "Program input: " << endl;
   cout << "   (a) amplitude scaling of input file channels" << endl;
   cout << endl;

   exit(1);
}


