//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sun Dec 28 15:04:24 GMT-0800 1997
// Last Modified: Mon Jan 12 21:33:32 GMT-0800 1998
// Filename:      ...sig/src/control/MidiOutPort/MidiOutPort.h
// Syntax:        C++ 
// $Smake:        cc -ansi -m486 -O -o %b %f -lg++ && strip %b
//


#ifndef _MIDIOUTPORT_H_INCLUDED
#define _MIDIOUTPORT_H_INCLUDED

#define MIDIOUTPORT(system)   MidiOutPort_ ## system

#ifdef VISUAL
   #define sys    visual
   #include "MidiOutPort_visual.h"
#else
   #define sys    unsupported
   #include "MidiOutPort_unsupported.h"
#endif


class MidiOutPort : protected MIDIOUTPORT(sys__) {
   public:
                  MidiOutPort        (void) : MIDIOUTPORT(sys)() {}
                  MidiOutPort        (int aPort, int autoOpen = 1) : 
                                         MIDIOUTPORT(sys)(aPort, autoOpen) {}
                 ~MidiOutPort()      { ~MIDIOUTPORT(sys)(); }

      void        close(void)        { MIDIOUTPORT(sys)::close(); }
      void        closeAll(void)     { MIDIOUTPORT(sys)::closeAll(); }
      const char* getName(void)      { return MIDIOUTPORT(sys)::getName(); }
      int         getNumPorts(void)  { return MIDIOUTPORT(sys)::getNumPorts(); }
      int         getPort(void)      { return MIDIOUTPORT(sys)::getPort(); }
      int         getPortStatus(void){ 
                     return MIDIOUTPORT(sys)::getPortStatus(); }
      int         open(void)         { return MIDIOUTPORT(sys)::open(); }
      int         rawsend(int command, int p1, int p2) {
                     return MIDIOUTPORT(sys)::rawsend(command, p1, p2); }
      int         rawsend(int command, int p1) {
                     return MIDIOUTPORT(sys)::rawsend(command, p1); }
      int         rawsend(int command) {
                     return MIDIOUTPORT(sys)::rawsend(command); }
      int         rawsend(uchar array, int size) {
                     return MIDIOUTPORT(sys)::rawsend(array, size); }
      void        setPort(int aPort) { MIDIOUTPORT(sys)::setPort(aPort); }
};



#endif  // _MIDIOUTPORT_H_INCLUDED



