//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sun Dec 28 15:18:46 GMT-0800 1997
// Last Modified: Mon Jan 12 20:05:27 GMT-0800 199
// Filename:      ...sig/src/control/MidiOutPort/visual/MidiOutPort_visual.h
// Syntax:        C++ 
// $Smake:        cc -ansi -m486 -O -o %b %f -lg++ && strip %b
//

#ifndef _MIDIOUTPUT_VISUAL_H_INCLUDED
#define _MIDIOUTPUT_VISUAL_H_INCLUDED
#ifdef VISUAL

typedef unsigned char uchar;


class MidiOutPort_visual {
   public:
                      MidiOutPort_visual         (void);
                      MidiOutPort_visual         (int aPort, int autoOpen = 1);
                     ~MidiOutPort_visual         ();

      void            close                      (void);
      void            closeAll                   (void);
      const char*     getName                    (void);
      int             getPort                    (void) const;
      int             getNumPorts                (void) const;
      int             getPortStatus              (void) const;
      int             rawsend                    (int command, int p1, int p2);
      int             rawsend                    (int command, int p1);
      int             rawsend                    (int command);
      int             rawsend                    (uchar* array, int size);
      int             open                       (void);
      void            setPort                    (int aPort);

   protected:
      int    port;     // the port to which this object belongs
 
      static int        objectCount;     // num of similar objects in existence
      static int*       portObjectCount; // objects connected to particular port
      static int*       openQ;           // for open/close status of port
      static int        numDevices;      // number of output ports
      static HMIDIOUT*  device;          // Windoze midi out device structure

   private:
      void            deinitialize               (void); 
      void            initialize                 (void); 
      void            setPortStatus              (int aStatus);
};


#endif  // VISUAL
#endif  // _MIDIOUTPUT_VISUAL_H_INCLUDED


