//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Tue Nov 12 15:17:54 PST 1996
// Last Modified: Tue Apr 29 21:38:49 GMT-0800 1997
// Filename:      .../sig/Filter/SoundFileOut/SoundFileOut.h
// Syntax:        C++ 
// $Smake:        cc -Wall -g -c %b.cc -I../../../include && rm -f %b.o
//

#ifndef _SOUNDFILEOUT_H_INCLUDED
#define _SOUNDFILEOUT_H_INCLUDED

#include "Filter.h"
#include "Definitions.h"
#include "SoundHeader.h"
#include <fstream.h>


class SoundFileOut : public Filter {
   public:
                     SoundFileOut      (char* aFileName, SoundHeader& header);
                    ~SoundFileOut      ();
      void           action            (void);
      void           close             (void);
      sampleType     output            (int channel);
 
   protected:
      char          *filename;
      SoundHeader    sndHeader;
      FileIO         outFile;
      long           sampleCount;
      ushort         outSample;


      void           determineSampleWritingFunction   (void);
      void           (SoundFileOut::*writeSample)     (sampleType aSample);

      // big endian samples
      void           writeSample8M_B                  (sampleType aSample);
      void           writeSample8L_B                  (sampleType aSample);
      void           writeSample16L_B                 (sampleType aSample);
      void           writeSample24L_B                 (sampleType aSample);
      void           writeSample32L_B                 (sampleType aSample);
      void           writeSample32F_B                 (sampleType aSample);
      void           writeSample64F_B                 (sampleType aSample);
  
      // little endian samples
      void           writeSample8M_L                  (sampleType aSample);
      void           writeSample8L_L                  (sampleType aSample);
      void           writeSample16L_L                 (sampleType aSample);
      void           writeSample24L_L                 (sampleType aSample);
      void           writeSample32L_L                 (sampleType aSample);
      void           writeSample32F_L                 (sampleType aSample);
      void           writeSample64F_L                 (sampleType aSample);

      uchar          linear16ToMulaw8                 (short aValue);

};


#endif  _SOUNDFILEOUT_H_INCLUDED

