//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Mon Oct 13 11:34:57 GMT-0800 1997
// Last Modified: Mon Oct 13 11:34:57 GMT-0800 1997
// Filename:      .../sig/src/midi/src/Timer/Timer.h
// Syntax:        C++ 
// $Smake:        cc -g -c %b.cc && rm -f %b.o
//

#ifndef _TIMER_H_INCLUDED
#define _TIMER_H_INCLUDED


typedef long millitime;


class Timer {
   public:
                              Timer              (void);
                              Timer              (long aSpeed);
                              Timer              (Timer& aTimer);
                             ~Timer              ();

      unsigned long long int  clockCycles        (void) const;
      long                    getCpuSpeed        (void) const;
      long                    getTicksPerSecond  (void) const;
      millitime               getTime            (void) const;
      void                    reset              (void);
      void                    setCpuSpeed        (long aSpeed);
      void                    setTicksPerSecond  (long aTickRate);
      void                    sync               (Timer& aTimer);

   protected:
      unsigned long long int  offset;          
      static unsigned long long int globalOffset;
      long                    cpuSpeed;         
      long                    ticksPerSecond;    
      unsigned long long int  conversionFactor;

      void                    calculateFactor   (void);

};

   
#endif  _TIMER_H_INCLUDED



